//=============================================================================
// DistanceViewTrigger: When triggered, triggers all pawns within its collision radius
// LOLZ ? Did it ever worked for Bot against ScriptedPawn ?
//=============================================================================
class MHDistanceViewTrigger extends Triggers;

function Trigger( actor Other, pawn EventInstigator )
{
	local Pawn P;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	{
		if ( (abs(Location.Z - P.Location.Z) < CollisionHeight + P.CollisionHeight)
			&& (VSize(Location - P.Location) < CollisionRadius) )
		{
			if ( P.IsA('ScriptedPawn') && !EventInstigator.IsA('ScriptedPawn') && P.Health > 0 )
			{
				ScriptedPawn(P).Hated = EventInstigator;
				ScriptedPawn(P).Enemy = EventInstigator;
				ScriptedPawn(P).GotoState('Attacking');
//				log (ScriptedPawn(P).GetHumanName()$" has been triggered by "$EventInstigator.GetHumanName());
			}
			P.Trigger(Other, EventInstigator);
		}
	}
}

defaultproperties
{
     bGameRelevant=True
}
