class MonsterBase expands Mutator config(MonsterHunt);

var DeathMatchPlus MyGame;
var int DiffScale, LevelMonster, MySkill, MovFix, PawnFix, FactFix, EndWarn, PathWarn,
		WaysCnt, WepCnt;
var name Tz;
var bool bAquiredData;
var config float MonsterMultiplier, md, nHumanBodyTime, nHumanChunkTime,
				nMonsterBodyTime, nMonsterChunkTime;
var config int	MinMonsterHealth, MaxMonsterHealth;
var config bool bTuneMovers, bNoGrabCheat, bCrushPawnBlocker, bVerboser,
				bNoGodMerc, bDoOldReplacing, bNoGodMonster, bNoAILeader, bCheckFactoryAttack;

function PostBeginPlay()
{
	MyGame = DeathMatchPlus(Level.Game);
	LevelMonster = MonsterHunt(Level.Game).MonsterSkill; //Transferred some skill here
		log ("Difficulty is set to:"@LevelMonster);
	Tz = MonsterHunt(Level.Game).TT;
	log ("Team word for monsters used is:"@Tz);
	CheckConfiguration();
	MovFix=0; PawnFix=0; FactFix=0; EndWarn=0; PathWarn=0; WaysCnt=0; WepCnt=0;
	setdiffscale();
	SetUpCurrent();
	StopNastySetup();
	Super.PostBeginPlay(); //Call others to gain changes
	if (bTuneMovers)
		fixmovers();
	if ( bDoOldReplacing )
	{
		if ( MonsterHunt(Level.Game).DefaultWeapon == Class'UnrealShare.DispersionPistol')
			MonsterHunt(Level.Game).DefaultWeapon = Class'MonsterHunt.OLDPistol';
	}
	SaveConfig();
	if ( bVerboser )
		SetTimer(Level.TimeDilation/2, False); //Will launch a foreach to gain data collected
}

function CheckConfiguration()
{
	if ( LevelMonster <= 1)
		MySkill = 0;
	if (LevelMonster == 2 || LevelMonster == 3)
		MySkill = 1;
	if (LevelMonster == 4 || LevelMonster == 5)
		MySkill = 2;
	if (LevelMonster == 6 || LevelMonster >= 7)
		MySkill = 3;
	if (MonsterMultiplier > 5)
		MonsterMultiplier = 5;
	if (MaxMonsterHealth < 2000)
		MaxMonsterHealth = 10000;
	if (MaxMonsterHealth > 1000000)
		MaxMonsterHealth = 1000000;
	if ( MinMonsterHealth > MaxMonsterHealth/2)
		MinMonsterHealth=MaxMonsterHealth/2;
	if (MonsterMultiplier < 0)
		MonsterMultiplier = 0;
//Note: Default has 180 seconds. I think it doesn't make any sense with such a value.
	if ( nHumanBodyTime >= 60.000000 || nHumanBodyTime < 1.000000 )
		nHumanBodyTime=60.000000;
	if( nHumanChunkTime >= 60.000000 || nHumanChunkTime < 1.000000 )
		nHumanChunkTime=60.000000;
	if( nMonsterBodyTime >= 60.000000 || nMonsterBodyTime < 1.000000 )
		nMonsterBodyTime=60.000000;
	if( nMonsterChunkTime >= 60.000000 || nMonsterChunkTime < 1.000000 )
		nMonsterChunkTime=60.000000;
}
//		Note for v5.04 Unofficial
// In 2014 we have other solution but will do sucks in clients
// Else we can solve it as configurable letting people to
// do what they want with weaponry
function bool ReplaceWith(actor Other, string aClassName) //reworking this stupid one for different reasons
{
	local Actor A;
	local class<Actor> aClass;
	local Pawn P;
	local Weapon W;
	local Rotator DropRot;
	local bool bMarked;
	local float ORadius, OHeight;

//	log ("Attempt replacing "$Other$" at "$GetAbsoluteTime());
	if ( Other.IsA('Inventory') && (Other.Location == vect(0,0,0)) )
		return false;
//Add-ons - Save primary collision and reduce manure to not mess the newer
	ORadius = Other.CollisionRadius;
	OHeight = Other.CollisionHeight;
	Other.SetCollisionSize(1,1);
//End Adds
	aClass = class<Actor>(DynamicLoadObject(aClassName, class'Class'));
	if ( aClass != None ) //Yes, checking if class can be used into "sand-box". Probably someone has sand-box often at lunch :P
	{
		aClass.Default.bCollideWhenPlacing = False;
		A = Spawn(aClass,Other.Owner,Other.tag,Other.Location+vect(0,0,1),Other.Rotation);
	}
	if ( Other.IsA('Inventory') && A != None )
	{
		if ( Inventory(Other).MyMarker != None )
		{
			Inventory(Other).MyMarker.markedItem = Inventory(A);
			if ( Inventory(A) != None ) //Is inventory ?
			{
				Inventory(A).SetCollisionSize(1,1);
				Inventory(A).MyMarker = Inventory(Other).MyMarker;
				A.SetLocation(Other.Location+vect(0,0,1));
				bMarked = True;
/*
				A.SetLocation(A.Location 
					+ (A.CollisionHeight - Other.CollisionHeight) * vect(0,0,1));
*/
				Inventory(A).bRotatingPickup=Inventory(Other).bRotatingPickup;
				Inventory(A).RespawnTime=Inventory(Other).RespawnTime;
			}
			Inventory(Other).MyMarker = None;
		}
		else if ( A.IsA('Inventory') && Inventory(Other).Instigator != None
			&& Inventory(Other).Instigator.bIsPawn && Vsize(A.Location-Other.Instigator.Location) <= A.CollisionRadius ) //Modification in here - Checking if has a Pawn Instigator
		{
			Inventory(A).Respawntime = 0.0;
			Inventory(A).bHeldItem = True;
			if (Inventory(A).IsA('Weapon'))
			{
				W = Weapon(Inventory(A));
				W.PickupMessageClass = Class'Botpack.PickupMessagePlus';
				if ( Other.Instigator.Health > 0 )
				{
					P = Other.Instigator;
					W.Instigator = P;
					if ( P.FindInventoryType(aClass) == None )
					{
//						log ("Found Instigator Pawn "$P$" for "$Inventory(A)$" as replacement for "$Other$".");
						if (!P.bIsPlayer)
							P.bIsPlayer=True;
						W.Touch(P);
					}
				}
			}
		}
		else
		{
			if ( !bMarked && Other.Owner == None)
			{
				Inventory(A).RemoteRole = ROLE_DumbProxy;
				Inventory(A).bCollideWorld = True;
				DropRot = Other.Rotation;
				DropRot.Pitch = Rand(32768);
				DropRot.Yaw = Rand(65536);
				Inventory(A).Velocity = vector(DropRot) * RandRange(250,301);
				Inventory(A).Velocity.Z = RandRange(250,451);
				Inventory(A).SetPhysics(PHYS_Falling);
				Inventory(A).GotoState('Pickup', 'Dropped');
//				log (Other$" spawned at "$Other.Location$" having RespawnTime "$Inventory(Other).RespawnTime);
				if ( MonsterHunt(Level.Game).bHaveASpawn )
				{
					Inventory(A).RespawnTime = 0.00;
				}
				else
					Inventory(A).RespawnTime = Inventory(Other).RespawnTime;
			}
			else
			{
				if ( Other.Owner != None && Other.Owner.bIsPawn )
				{
//					log ("Detected a spawn "$Other$" with Owner "$Other.Owner$". Inventory will be set.");
					P = Pawn(Other.Owner);
					if ( Inventory(A).IsA('Weapon'))
					{
						W = Weapon(Inventory(A));
						W.ReSpawnTime = 0.0;
						W.BecomeItem();
						W.Instigator = P;
						P.AddInventory(W);
						W.GiveAmmo(P);
						W.WeaponSet(P);
					}
				}
			}
		}
	}
	else
	{
		log (Other$" looks badly placed at "$Other.Location$". Goodbye !!!");
		Other.SetCollisionSize(ORadius,OHeight);
	}
	if ( A != None )
	{
		if ( Inventory(A) != None && Inventory(A).MyMarker != None )
			A.SetCollisionSize(ORadius,OHeight);
//===================
		if (A.IsA('ASMD') && Other.IsA('OLASMD'))
		{
			ASMD(A).hitDamage = ASMD(Other).hitDamage;
		}
//===================
		A.event = Other.event;
		A.tag = Other.tag;
		A.RotationRate = Other.RotationRate;
		A.bFixedRotationDir = Other.bFixedRotationDir;
//		log ( Other$" is now "$A );
		return true;
	}
	return false;
}

function bool AlwaysKeep(Actor Other)
{
	local bool bTemp;

	if ( Other.IsA('ScriptedPawn') )
	{
/*
	if (ScriptedPawn(Other).Shadow == None)
			MonsterHunt(Level.Game).SetPawnDifficulty(MonsterHunt(Level.Game).MonsterSkill, ScriptedPawn(Other));
		return true;
// Ending abomination
*/
		ScriptedPawn(Other).Team = 1;
		if ( MonsterHunt(Level.Game).bDumbDown )
			ScriptedPawn(Other).TeamTag = MonsterHunt(Level.Game).TT;
	}

	if ( Other.IsA('ThingFactory') )
		return true;

	if ( Other.IsA('MonsterWaypoint'))
		return true;

/*
Nah, we demand: QUIET !!!
	if ( Other.IsA('SpawnPoint') )
		return true;
*/
	if ( NextMutator != None )
		return ( NextMutator.AlwaysKeep(Other) );
	return false;
}

function bool IsRelevant(Actor Other, out byte bSuperRelevant)
{
	local bool bResult;
	local ScriptedPawn S;

	bResult = CheckReplacement(Other,bSuperRelevant);
	if ( ScriptedPawn(Other) != none && bResult )
	{
		S = ScriptedPawn(Other);
		ScriptedPawn(Other).bGameRelevant=False;
		ScriptedPawn(Other).NetUpdateFrequency = 20.000000;
		ScriptedPawn(Other).NetPriority = 3.000000;
		S.bCanBePissed = False;
		S.bIgnoreFriends = True;
		S.OddsOfAppearing = 1.000000;
		SetPawnDifficulty(S);
		bResult = True;
	}

	if ( ThingFactory(Other) != None && bResult )
		bResult = True;

	if ( Other.class == class 'MonsterHunt.SpawnPoint' )
		bResult = True;

	if ( bResult && (NextMutator != None) )
		bResult = NextMutator.IsRelevant(Other, bSuperRelevant);
	return bResult;
}

function SetUpCurrent()
{
	local PawnNotify Mp;

	Mp = Spawn(class 'PawnNotify');
	if ( Mp != None )
	{
		Mp.AnimalChunk = nMonsterChunkTime;
		Mp.HumanChunk = nHumanChunkTime;
	}
}

function fixmovers()
{
	local mover M;
	local Trigger T;
	local Counter Cr;
	local Dispatcher Ds;
	local ScriptedPawn S;
	local int i;

	foreach AllActors(class 'Mover', M)
	{
		if (M != None)
		{
			M.NetUpdateFrequency = 10.000000;
//			log ("Mover "@M@" updated to frequency "@M.NetUpdateFrequency);
			if (M.MoverEncroachType == ME_CrushWhenEncroach && !M.bTriggerOnceOnly)
			{
				M.BumpType = BT_PawnBump;	//If I was killed why Bot need to not be killed, even is blocked, fag ?
				if ( M.EncroachDamage <= 0 )
					M.EncroachDamage = 5000000;
				MovFix++;
			}
			foreach AllActors (class 'Trigger', T)
			{
				if (T != None && T.Event == M.Tag && !M.bTriggerOnceOnly && T.InitialState == 'NormalTrigger' && !T.bTriggerOnceOnly)
					if (T.TriggerType == TT_PlayerProximity)
					{
						T.TriggerType = TT_PawnProximity;
						MovFix++;
					}
			}
			foreach AllActors (class 'Counter', Cr)
			{
				if ( Cr != None && M.InitialState == 'TriggerControl' && Cr.Event == M.Tag )
				{
					log ("Mover "$M$" is messed up with "$M.InitialState$". Will adjust InitialState and Encroaching method to avoid other errors.");
					log ("Being triggered by "$Cr$", will be properly set.");
					M.InitialState = 'TriggerOpenTimed'; M.MoverEncroachType = ME_IgnoreWhenEncroach; M.bTriggerOnceOnly = True;
					MovFix++;
				}
			}
			foreach AllActors (class 'ScriptedPawn', S)
			{
				if ( S != None && M.InitialState == 'TriggerControl' && S.Event == M.Tag )
				{
					log ("Mover "$M$" is messed up with "$M.InitialState$". Will adjust InitialState and Encroaching method to avoid other error.");
					log ("Being triggered by "$S$", will be properly set.");
					M.InitialState = 'TriggerOpenTimed'; M.MoverEncroachType = ME_IgnoreWhenEncroach; M.bTriggerOnceOnly = True;
					MovFix++;
				}
			}
			foreach AllActors (class 'Dispatcher', Ds)
			{
				if ( Ds != None )
				{
					for (i=0;i<8;i++)
					{
						if ( Ds.OutEvents[i] == M.Tag && M.InitialState == 'TriggerControl' )
						{
							log ("Mover "$M$" is messed up with "$M.InitialState$". Will adjust InitialState and Encroaching method to avoid other error.");
							log ("Being triggered by "$Ds$" having event OutEvents["$i$"]: "$Ds.OutEvents[i]$", will be properly set.");
							M.InitialState = 'TriggerOpenTimed'; M.MoverEncroachType = ME_IgnoreWhenEncroach; M.bTriggerOnceOnly = True;
							MovFix++;
						}
					}
				}
			}
			
			if ( M.bTriggerOnceOnly )
			{
				if (M.MoverEncroachType == ME_ReturnWhenEncroach)
				{
					M.MoverEncroachType = ME_IgnoreWhenEncroach;
					log ("Detected & Resolved a Mover Triggered Once With ReturnWhenEncroach >> "@M.name);
					MovFix++;
				}
				if ( M.InitialState == 'TriggerControl' )
				{
					log ("Wrong? A mover with TriggerControl shouldn't be set bTriggerOnceOnly >> "@M.Name);
					log ("Attempt to fix mover state >> "@M.Name@" to TriggerOpenTimed.");
					M.InitialState = 'TriggerOpenTimed';
					if ( M.InitialState == 'TriggerOpenTimed' )
					{
						log ("Succesfully fixed.");
						MovFix++;
					}
					else
						log ("Fixing failed !!!");
				}
			}
			if (bNoGrabCheat)
			if (M.bUseTriggered == True)
			{
				M.bUseTriggered = False;
				log ("Detected & Resolved a Mover to not be cheated by GRAB command >> " @M.name);
				MovFix++;
			}
			if (M.bDamageTriggered)
				log(M@" >> is damage triggered");
			if (bCrushPawnBlocker)
			if (!M.bTriggerOnceOnly && M.MoverEncroachType == ME_ReturnWhenEncroach)
			{
				M.MoverEncroachType = ME_CrushWhenEncroach;
				M.EncroachDamage = 5000000;
				log ("Detected & Resolved a Mover to not be turned back without suffering big damage >> "@M.name);
				MovFix++;
			}
			if (!M.bTriggerOnceOnly && M.DelayTime < md && M.InitialState != 'TriggerControl')
			{
				M.DelayTime = md;
				MovFix++;
			}
			if (!M.bTriggerOnceOnly && M.BumpType == BT_PlayerBump && ( M.InitialState == 'StandOpenTimed' || M.InitialState == 'BumpOpenTimed' || M.InitialState == 'BumpButon'))
			{
				M.BumpType = BT_PawnBump;
				MovFix++;
			}
		}
	}
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	local Inventory Inv;

	bSuperRelevant = 1;
	if ( Other.IsA('Carcass') && (!Other.bStatic && !Other.bNoDelete ) )
	{
		if ( Other.IsA('UTHumanCarcass') )
			Other.LifeSpan = nHumanBodyTime;
		if ( Other.IsA('UTCreatureChunks') )
			Other.LifeSpan = nHumanChunkTime;
		if ( Other.IsA('CreatureCarcass') )
			Other.LifeSpan = nMonsterBodyTime;
		if ( Other.IsA('CreatureChunks') )
			Other.LifeSpan = nMonsterChunkTime;
	}

	if ( Other.IsA('ScriptedPawn') )
		return true;

	if ( MyGame.bMegaSpeed && Other.bIsPawn && Pawn(Other).bIsPlayer )
	{
		Pawn(Other).GroundSpeed *= 1.4;
		Pawn(Other).WaterSpeed *= 1.4;
		Pawn(Other).AirSpeed *= 1.4;
		Pawn(Other).AccelRate *= 1.4;
	}

	Inv = Inventory(Other);
 	if ( Inv == None )
	{
		bSuperRelevant = 0;
		if ( Other.IsA('TorchFlame') )
			Other.NetUpdateFrequency = 0.5;
		return true;
	}

	if ( MyGame.bNoviceMode && MyGame.bRatedGame && (Level.NetMode == NM_Standalone) )
		Inv.RespawnTime *= (0.5 + 0.1 * MyGame.Difficulty);

	if ( Other.IsA('Weapon') )
	{
		if ( bDoOldReplacing )
		{
			if (Other.IsA('quadshot'))
			{
				ReplaceWith( Other, "MonsterHunt.OLFlakCannon" );
				return false;
			}
			if ( Other.IsA('Stinger'))
			{
				ReplaceWith(Other, "MonsterHunt.OLStinger");
				return false;
			}
			if ( Other.IsA('Rifle'))
			{
				ReplaceWith( Other, "MonsterHunt.OLRifle" );
				Return false;
			}
			if ( Other.IsA('Razorjack') )
			{
				ReplaceWith(Other, "MonsterHunt.OLRazorjack"); //Solved
				Return false;
			}
			if ( Other.IsA('Minigun'))
			{
				ReplaceWith( Other, "MonsterHunt.OLMinigun" );
				return false;
			}
			if ( Other.IsA('AutoMag'))
			{
				ReplaceWith( Other, "MonsterHunt.OLAutoMag" );
				return false;
			}
			if ( Other.IsA('Eightball'))
			{
				ReplaceWith( Other, "MonsterHunt.OLEightball" );
				return false;
			}
			if ( Other.IsA('FlakCannon') )
			{
				ReplaceWith( Other, "MonsterHunt.OLFlakCannon" );
				return false;
			}
			if ( Other.IsA('ASMD')) //!!Flag
			{
				ReplaceWith( Other, "MonsterHunt.OLASMD" );
				return false;
			}
			if ( Other.IsA('GesBioRifle') )
			{
				ReplaceWith( Other, "MonsterHunt.OLGESBioRifle" );
				return false;
			}
			if ( Other.IsA('dispersionpistol') )
			{
				ReplaceWith( Other, "MonsterHunt.OLDPistol" );
				return false;
			}
		}
		if( Other.Class == Class'minigun2')
		{
			ReplaceWith(Other,"MonsterHunt.Eminigun2");
			return false;
		}
		if( Other.Class == Class'PulseGun')
		{
			ReplaceWith(Other,"MonsterHunt.EPulseGun");
			return false;
		}
		if ( Other.class == class 'UT_Eightball')
		{
			ReplaceWith(Other,"MonsterHunt.EUT_Eightball");
			return False;
		}
		bSuperRelevant = 0;
		return true;
	}

	if ( Other.IsA('Pickup') )
	{
		if (Other.IsA('WarHeadAmmo'))
		{
			WarheadAmmo(Other).AmmoAmount=2;
			WarheadAmmo(Other).Default.AmmoAmount=2;
		}
		Pickup(Other).bAutoActivate = true;
		Pickup(Other).PickupMessageClass = Class'Botpack.PickupMessagePlus';
		if ( Other.IsA('TournamentPickup') )
			return true;
		if ( bDoOldReplacing )
		{
			if ( Other.IsA('WeaponPowerup') )
			{
				ReplaceWith(Other,"MonsterHunt.osWeaponPowerup");
				return False;
			}
			if ( Other.IsA('Amplifier') )
			{
				ReplaceWith(Other,"MonsterHunt.osAmplifier");
				return False;
			}
		}
	}
	if ( Other.IsA('TournamentHealth') )
		return true;

	if ( Level.Game.IsA('MonsterHuntArena') )
	{
		if ( Other.IsA('Weapon') )
		{
			Weapon(Other).RespawnTime = 3;
		}

		else if ( Other.IsA('Ammo') )
		{
			Ammo(Other).RespawnTime = 3;
		}
	return true;
	}

	bSuperRelevant = 0;
	return true;
}

function setdiffscale()
{
	if (LevelMonster == 1)
		DiffScale = 90;
	if (LevelMonster == 2)
		DiffScale = 100;
	if (LevelMonster == 3)
		DiffScale = 110;
	if (LevelMonster == 4)
		DiffScale = 120;
	if (LevelMonster == 5)
		DiffScale = 130;
	if (LevelMonster == 6)
		DiffScale = 140;
	if (LevelMonster == 7)
		DiffScale = 150;
}

function SetPawnDifficulty( ScriptedPawn S )
{
	local Texture Sk;
	local Texture ms0;
	local Texture ms1;
	local Texture ms2;
	local Texture ms3;
	local Texture ms4;
	local Texture ms5;
	local Texture ms6;
	local Texture ms7;
	local string MSH, Prj;

	// Diff crap constantly checked has been assigned once, no need millions times called
	// Recheck dumb mapping ideeas - that's why I keep this magic function here
	S.DamageScaling = S.DamageScaling * DiffScale / 100;
	if ( S.DrawScale > 3 )
		S.DrawScale = 3;
	if ( S.Mesh != None )
	{
		MSH = Caps(S.Mesh);
//		log ("Mesh stored is "$MSH);
	}
	else MSH = Caps(Tz);
	if ( S.RangedProjectile != None )
	{
		Prj = Caps(S.RangedProjectile);
//		log ("Projectile for "$S$" stored is "$Proj);
	}
	else Prj = Caps(Tz);
	if (S.PeripheralVision < -1.6) S.PeripheralVision = -1.6;
	if (S.PeripheralVision > -0.2) S.PeripheralVision = -0.2;
	if (S.Aggressiveness < 0.8) S.Aggressiveness = 0.8;
	// I'll bet you didn't fought with monsters on Skill 3 :P, :)) - MY other crap works with high accuracy.
	// Troubles ? Pick other server, :P.
	S.Health = (S.Health * DiffScale) / 100;
	if ( MonsterMultiplier > 1 )
	{
		S.Health = Clamp(S.Health*MonsterMultiplier,MinMonsterHealth,MaxMonsterHealth); //Use Minimum-Health at once with Multiplier
	}
	if ( S.Health > MaxMonsterHealth )
		S.Health = MaxMonsterHealth;
	S.SightRadius = (S.Default.SightRadius * DiffScale) / 100;
	S.Aggressiveness = (S.Default.Aggressiveness * DiffScale) / 100;
	S.MeleeRange = S.Default.MeleeRange; //Yea, idiots ! Fixed craps right now :P !
	S.CombatStyle = (S.Default.CombatStyle * DiffScale) / 100;
	S.ProjectileSpeed = (S.Default.ProjectileSpeed * DiffScale) / 100;
	S.GroundSpeed = (S.Default.GroundSpeed * DiffScale) / 100;
	S.AirSpeed = (S.Default.AirSpeed * DiffScale) / 100;
	S.WaterSpeed = (S.Default.WaterSpeed * DiffScale) / 100;
	if ( bNoGodMonster )
	if (S.ReducedDamagePct > 0)
	{
		S.ReducedDamageType = '';
		S.ReducedDamagePct = 0;
	}
	S.JumpZ = (S.JumpZ * Diffscale) / 100; //... Done, small adjustments changing style.
	//Now clamp bullshit
	if (S.GroundSpeed > 500) 
		S.GroundSpeed = 500;
	if (S.HearingThreshold < 0.1)
		S.HearingThreshold = 0.1;
	if (S.HearingThreshold > 0.9)
		S.HearingThreshold = 0.9;
	if (S.SightRadius < 3500)
		S.SightRadius = 3500;
	if (S.SightRadius > 4500)
		S.SightRadius = 4500;
	if (S.AccelRate > 700)
		S.AccelRate = 700;
	if (S.AirSpeed > 500)
		S.AirSpeed = 500;
	if (S.WaterSpeed > 400)
		S.WaterSpeed = 400;
	if (S.CombatStyle > 0.9)
		S.CombatStyle = 0.9;
	if (S.CombatStyle < 0.3)
		S.CombatStyle = 0.3;
	if (S.Aggressiveness > 1.0)
		S.Aggressiveness = 1.0;
	if (S.Aggressiveness < 0.5)
		S.Aggressiveness = 0.5;
	if ( MonsterHunt(Level.Game).bStartedHunt )
		S.AttitudeToPlayer = ATTITUDE_Frenzy;
	if (Right((MSH),6)=="SQUID1")
//	if (S.Mesh == LodMesh 'Squid1')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealI.Skins.JSquid1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealI.Skins.JSquid1';
		S.Mesh = LodMesh 'ExSquid1';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
//		S.Fatness = S.Default.Fatness;
	}
	if (Right((MSH),7)=="NALICOW")
//	if (S.Mesh == LodMesh 'NaliCow')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealShare.Skins.JCow1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JCow1';
		S.Mesh = LodMesh 'ExNaliCow';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
//		S.Style = STY_Masked;
	}
	if (Right((MSH),4)=="FLYM")
//	if (S.Mesh == LodMesh 'FlyM')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealShare.Skins.JFly1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JFly1';
		S.Mesh = LodMesh 'ExFlyM';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
//		S.Style = STY_Masked;
	}
	if (Right((MSH),6)=="SLITH1")
//	if (S.Mesh == LodMesh 'Slith1')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealShare.Skins.JSlith1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealShare.Skins.JSlith1';
		S.Mesh = LodMesh 'ExSlith1';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
//		S.Style = STY_Masked;
	}
	if (Right((MSH),6)=="TITAN1")
//	if (S.Mesh == LodMesh 'Titan1')
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		if (S.Skin != None && S.Skin != Texture'UnrealI.Skins.JTitan1')
			Sk = S.Skin;
		else
			Sk = Texture'UnrealI.Skins.JTitan1';
		S.Mesh = LodMesh 'ExTitan1';
		S.Skin = Sk;
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
	}
	if (Right((MSH),7)=="SPINNER")
//	if ( S.Mesh == LodMesh 'Spinner' )
	{
		ms0 = S.MultiSkins[0];
		ms1 = S.MultiSkins[1];
		ms2 = S.MultiSkins[2];
		ms3 = S.MultiSkins[3];
		ms4 = S.MultiSkins[4];
		ms5 = S.MultiSkins[5];
		ms6 = S.MultiSkins[6];
		ms7 = S.MultiSkins[7];
		sk = S.Skin;
		S.Mesh = LodMesh 'ExSpinner';
		if ( S.Skin != None && S.Skin != S.Default.Skin )
			S.Skin = Sk;
/*		else
			S.Skin = Texture 'ExJSpinner1';
*/
		S.MultiSkins[0] = ms0;
		S.MultiSkins[1] = ms1;
		S.MultiSkins[2] = ms2;
		S.MultiSkins[3] = ms3;
		S.MultiSkins[4] = ms4;
		S.MultiSkins[5] = ms5;
		S.MultiSkins[6] = ms6;
		S.MultiSkins[7] = ms7;
		S.Fatness = S.Default.Fatness;
	}
	if (S.IsA('Pupae'))
	{
		if (S.RangedProjectile == None) //Stupid Check for idiotic mapping
			S.bHasRangedAttack = False;
	}
	if (S.IsA('Manta'))
	{
		if (S.RangedProjectile == None)
			S.bHasRangedAttack = False;
	}
	if (bNoGodMerc)
	if (S.IsA('Mercenary'))
	{
		Mercenary(S).bHasInvulnerableShield = False;
		Mercenary(S).invulnerableCharge = 0.2;
	}

	if (Right((Prj),15)=="BRUTEPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.ExBruteProjectile';
		goto EndProj;
	}
//------------------
	if (Right((Prj),10)=="MERCROCKET")
	{
		S.RangedProjectile = class 'MonsterHunt.ExMercRocket';
		goto EndProj;
	}
//------------------
	if (Right((Prj),13)=="WARLORDROCKET")
	{
		S.RangedProjectile = class 'MonsterHunt.ExWarlordRocket';
		goto EndProj;
	}
//------------------ Using alternate decals ? Let's say yes, probably I'll get rid of these using others.
	if (Right((Prj),11)=="GASBAGBELCH")
	{
		S.RangedProjectile = class 'MonsterHunt.mhGasBagBelch';
		goto EndProj;
	}
	if (Right((Prj),9)=="KRAALBOLT")
	{
		S.RangedProjectile = class 'MonsterHunt.mhKraalBolt';
		goto EndProj;
	}
	if (Right((Prj),14)=="ELITEKRALLBOLT")
	{
		S.RangedProjectile = class 'MonsterHunt.mhEliteKrallBolt';
		goto EndProj;
	}
	if (Right((Prj),16)=="SKAARJPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.mhSkaarjProjectile';
		goto EndProj;
	}
	if (Right((Prj),15)=="QUEENPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.mhqueenprojectile';
		goto EndProj;
	}
	if (Right((Prj),18)=="TENTACLEPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.mhTentacleProjectile';
		goto EndProj;
	}
//-- Expect Lava Bullshit modifications first, in order to be slapped down
	if (Right((Prj),19)=="LAVASLITHPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.mhLavaSlithProjectile';
		goto EndProj;
	}
//----------------
	if (Right((Prj),15)=="SLITHPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.mhSlithProjectile';
		goto EndProj;
	}
	if (Right((Prj),13)=="SEEKINGROCKET")
	{
		S.RangedProjectile = class 'MonsterHunt.OSSeekingRocket';
		goto EndProj;
	}
	if (Right((Prj),10)=="RAILROCKET")
	{
		S.RangedProjectile = class 'MonsterHunt.OLTazerProj';
		goto EndProj;
	}

	if (Right((Prj),7)==".ROCKET")
	{
		S.RangedProjectile = class 'MonsterHunt.OSRocket';
		goto EndProj;
	}

	if (Right((Prj),9)=="TAZERPROJ")
	{
		S.RangedProjectile = class 'MonsterHunt.OLTazerProj';
		goto EndProj;
	}
	if (Right((Prj),10)=="RAZORBLADE")
	{
		S.RangedProjectile = class 'MonsterHunt.OSRazorBlade';
		goto EndProj;
	}
	if (Right((Prj),15)=="RAZORBLADEALT")
	{
		S.RangedProjectile = class 'MonsterHunt.OSRazorBlade';
		goto EndProj;
	}
	if (Right((Prj),14)=="DISPERSIONAMMO" || Right((Prj),6)=="PLASMA")
	{
		S.RangedProjectile = class 'MonsterHunt.OSDispersionAmmo';
		goto EndProj;
	}
	if (Right((Prj),10)=="ENERGYBOLT")
	{
		S.RangedProjectile = class 'MonsterHunt.MHEnergyBolt';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO2")
	{
		S.RangedProjectile = class 'MonsterHunt.OSDAmmo2';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO3")
	{
		S.RangedProjectile = class 'MonsterHunt.OSDAmmo3';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO4")
	{
		S.RangedProjectile = class 'MonsterHunt.OSDAmmo4';
		goto EndProj;
	}
	if (Right((Prj),6)=="DAMMO5")
	{
		S.RangedProjectile = class 'MonsterHunt.OSDAmmo5';
		goto EndProj;
	}
	if (Right((Prj),9)=="FLAKSHELL")
	{
		S.RangedProjectile = class 'MonsterHunt.OSFlakShell';
		goto EndProj;
	}
	if (Right((Prj),17)=="STINGERPROJECTILE")
	{
		S.RangedProjectile = class 'MonsterHunt.OSStingerProjectile';
		goto EndProj;
	}
	if (Right((Prj),7)=="BIODROP")
	{
		S.RangedProjectile = class 'MonsterHunt.OSBioGel';
		goto EndProj;
	}
	if (Right((Prj),9)=="BIGBIOGEL")
	{
		S.RangedProjectile = class 'MonsterHunt.OSBigBiogel';
		goto EndProj;
	}
	if (Right((Prj),6)=="BIOGEL")
	{
		S.RangedProjectile = class 'MonsterHunt.OSBioGel';
		goto EndProj;
	}
	if (Right((Prj),11)=="MASTERCHUNK")
	{
		S.RangedProjectile = class 'MonsterHunt.OSMasterChunk';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK1")
	{
		S.RangedProjectile = class 'MonsterHunt.OSChunk1';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK2")
	{
		S.RangedProjectile = class 'MonsterHunt.OSChunk2';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK3")
	{
		S.RangedProjectile = class 'MonsterHunt.OSChunk3';
		goto EndProj;
	}
	if (Right((Prj),6)=="CHUNK4")
	{
		S.RangedProjectile = class 'MonsterHunt.OSChunk4';
		goto EndProj;
	}

	if (Right((Prj),8)==".GRENADE")
	{
		S.RangedProjectile = class 'MonsterHunt.OSGrenade';
		goto EndProj;
	}

// --- Projectile end. Add others needed before this REMARK LINE
EndProj: //Come here after change - no longer checking if found the match

	if (S.BaseEyeHeight < S.CollisionHeight/1.5)
		S.BaseEyeHeight = S.CollisionHeight/1.5;
	S.Intelligence = BRAINS_HUMAN;
	S.bInitialFear=False;
	S.Skill = Level.Game.Difficulty;
	if (S.bCanWalk && !S.bCanFly)
		S.SetPhysics(PHYS_Falling);
	if (S.Weapon != None)
		S.bIsPlayer = False;
	Sk = None;
	ms0 = None;
	ms1 = None;
	ms2 = None;
	ms3 = None;
	ms4 = None;
	ms5 = None;
	ms6 = None;
	ms7 = None;
}

function Mutate(string MutateString, PlayerPawn Sender)
{
	local Pawn P;

	if ( MutateString ~= "version" )
		Sender.ClientMessage("Monster Hunt V5.04 Unofficial", 'MonsterCriticalEvent', True);

	if ( NextMutator != None )
		NextMutator.Mutate(MutateString, Sender);
}

function StopNastySetup()
{
	local int PP;
	local Actor A;
	local bool bPatrols;
	local PatrolPoint Po;

	PP = 0;

	foreach AllActors (class 'PatrolPoint', Po)
	{
		if ( Po != None )
		{
			PP++;
			bPatrols = True;
		}
	}
	foreach AllActors (class 'Actor', A)
	{
		if (A.IsA('CreatureFactory'))
		{
			if ( CreatureFactory(A).Orders == 'Roaming' )
			{
				CreatureFactory(A).Orders = '';
				log ("Illegal settings discovered and removed at"@CreatureFactory(A));
				FactFix++;
			}
			if (CreatureFactory(A).Orders == 'Patroling' && !bPatrols)
			{
				CreatureFactory(A).Orders = '';
				log ("Order <Patroling> is invalid without a PatrolPoint at"@CreatureFactory(A)@"and has been eliminated.");
				FactFix++;
			}
			if ( CreatureFactory(A).itemtag == CreatureFactory(A).Tag )
			{
				log ("Detected bad self triggering at "$CreatureFactory(A)$". Screwing with string"@Tz);
				CreatureFactory(A).itemtag = Tz;
				FactFix++;
			}
			if ( MonsterHunt(Level.Game).bDumbDown && bCheckFactoryAttack)
			{
				if ( !CreatureFactory(A).bOnlyPlayerTouched )
				{
					CreatureFactory(A).bOnlyPlayerTouched = True;
					log ("Removed wild touch ignition at "$CreatureFactory(A)$".");
					FactFix++;
				}
			}
		}
		if (A.IsA('ScriptedPawn'))
		{
			if ( ScriptedPawn(A).Orders == 'Roaming' || ( ScriptedPawn(A).Orders == 'Patroling' && !bPatrols ) || ScriptedPawn(A).Orders == 'Hunting' )
			{
				log (ScriptedPawn(A)$" having order "$ScriptedPawn(A).Orders$" has been reset because it has no logic here.");
				ScriptedPawn(A).Orders = '';
				ScriptedPawn(A).GoToState('Waiting');
				PawnFix++;
			}
			if ( bNoAILeader )
			if (ScriptedPawn(A).bTeamLeader)
			{
				ScriptedPawn(A).bTeamLeader = False;
				log (ScriptedPawn(A)@"won't be a Leader thanks to original A.I. coding.");
				PawnFix++;
			}
		}
	}
		log ("Some settings were checked.");
		if (bPatrols)
		{
			if (PP < 2)
				log ("This level contains"@PP@"PatrolPoint. Interesting!");
			else
				log ("This level contains"@PP@"PatrolPoints.");
		}
		else
			log ("This level doesn't include any PatrolPoint.");
}

event Timer()
{
	if ( !bAquiredData )
	{
		BroadcastMessage("Verboser is processing data...",True ,'InfoEventPlus');
		GetMapData();
		bAquiredData=True;
	}
/*
	else
		BroadcastMessage("Data Ready...",True,'InfoEventPlus');
*/
}

function GetMapData()
{
	local Actor A;

	foreach AllActors(class'Actor',A)
	{
		if (A.IsA('MonsterEnd'))
			EndWarn++;
		if (A.IsA('Weapon') && !Weapon(A).bHeldItem)
			WepCnt++;
		if (A.IsA('PathNode'))
			PathWarn++;
		if (A.IsA('MonsterWayPoint'))
			WaysCnt++;
	}
	MonsterHunt(Level.Game).MovFix = MovFix;
	MonsterHunt(Level.Game).PawnFix = PawnFix;
	MonsterHunt(Level.Game).FactFix = FactFix;
	MonsterHunt(Level.Game).EndWarn = EndWarn;
	MonsterHunt(Level.Game).WepCnt = WepCnt;
	MonsterHunt(Level.Game).PathWarn = PathWarn;
	MonsterHunt(Level.Game).WaysCnt = WaysCnt;
	MonsterHunt(Level.Game).bAbleToInfo = True;
}

defaultproperties
{
   bVerboser=True
   bDoOldReplacing=True
   bTuneMovers=True
   bNoGrabCheat=True
   bCrushPawnBlocker=True
   bNoGodMonster=True
   bNoAILeader=True
   nHumanBodyTime=3.000000
   nHumanChunkTime=1.500000
   nMonsterBodyTime=5.000000
   nMonsterChunkTime=4.000000
   bCheckFactoryAttack=True
   md=0.250000
   bNoGodMerc=True
   MinMonsterHealth=50
   MaxMonsterHealth=1000000
   MonsterMultiplier=0
}
