class MonsterHunt expands Domination config(MonsterHunt);

var config bool bUseTeamSkins;
var config int MonsterSkill;
var config int Lives;
var bool bUseLives,bStartedHunt,bGarbRemoved,bHaveASpawn,bAbleToInfo; //self-handled
var string TimeOutMessage;
var int LivePpl,PlainPpl,LastPoint,CT,NumPoints,MonstersTotal,HuntersTotal,MsgTmr;
var int MovFix, PawnFix, FactFix, EndWarn, PathWarn, WaysCnt, WepCnt;
var (AI) config name TT;
var Actor MHTarget;
var NavigationPoint PointToTarget;

event PreBeginPlay() //Don't call me too much - and screwed well
{
	StartTime = 0;
//	SetGameSpeed(GameSpeed); //Not in here
	Level.bNoCheating = bNoCheating;
	Level.bAllowFOV = bAllowFOV;

	if (GameReplicationInfoClass != None)
		GameReplicationInfo = Spawn(GameReplicationInfoClass);
	else
		GameReplicationInfo = Spawn(class'GameReplicationInfo');
	InitGameReplicationInfo();
}

function SetGameSpeed(Float T)
{
	local float InitialSpeed;

	GameSpeed = FMax(T,0.1); //Initial setup could be awesome but is not
	InitialSpeed = GameSpeed;
	SaveConfig();
	GameSpeed = FMax(T*1.000001, 0.1);	// Screwing dumb Set TimeDilation from Level playing in Classic style
	Level.TimeDilation = GameSpeed;	// Even in default MH using Classic Core from menu
	SetTimer(Level.TimeDilation, True);
	GameSpeed = InitialSpeed;
}

function PostBeginPlay()
{
	local int i;
	local ScriptedPawn S;
	local pawn pawnlink;
	local MonsterWaypoint WP;

	LastPoint = 0;
	bStartedHunt = False;

//	MonsterReplicationInfo(GameReplicationInfo).Lives = Lives;

	foreach AllActors(class'MonsterWaypoint', WP)
		NumPoints ++;

	foreach AllActors(class'ScriptedPawn', S)
	{
		if ( !S.IsA('Nali') && !S.IsA('Cow') /*&& !S.IsA('NaliRabbit')*/ )
			S.AttitudeToPlayer=ATTITUDE_Ignore;
/*
		if (S.Shadow == None)
			SetPawnDifficulty(MonsterSkill, S);
*/
	}

	Countmonsters();
	MonsterReplicationInfo(GameReplicationInfo).Monsters = MonstersTotal;
	MonsterReplicationInfo(GameReplicationInfo).Lives = Lives;
	MonsterReplicationInfo(GameReplicationInfo).bUseTeamSkins = bUseTeamSkins;
	if ( MonsterReplicationInfo(GameReplicationInfo).Lives <= 0 )
		MonsterReplicationInfo(GameReplicationInfo).bUseLives = False;
	else
		MonsterReplicationInfo(GameReplicationInfo).bUseLives = True;
	Super.PostBeginPlay();
}
/*
function SetPawnDifficulty( int Diff, ScriptedPawn S )
{
	local int DiffScale;

	switch (Diff)
	{
		case 0:
			DiffScale = 80;
			break;
		case 1:
			DiffScale = 90;
			break;
		case 2:
			DiffScale = 100;
			break;
		case 3:
			DiffScale = 110;
			break;
		case 4:
			DiffScale = 120;
			break;
		case 5:
			DiffScale = 130;
			break;
		case 6:
			DiffScale = 140;
			break;
		case 7:
			DiffScale = 150;
			break;
	}
	S.Health = (S.Health * DiffScale) / 100;
	S.SightRadius = (S.SightRadius * DiffScale) / 100;
	S.Aggressiveness = (S.Aggressiveness * DiffScale) / 100;
	S.ReFireRate = (S.ReFireRate * DiffScale) / 100;
	S.CombatStyle = (S.CombatStyle * DiffScale) / 100;
	S.ProjectileSpeed = (S.ProjectileSpeed * DiffScale) / 100;
	S.GroundSpeed = (S.GroundSpeed * DiffScale) / 100;
	S.AirSpeed = (S.AirSpeed * DiffScale) / 100;
	S.WaterSpeed = (S.WaterSpeed * DiffScale) / 100;

	if (S.IsA('Brute'))
		Brute(S).WhipDamage = (Brute(S).WhipDamage * DiffScale) / 100;
	if (S.IsA('Gasbag'))
		Gasbag(S).PunchDamage = (Gasbag(S).PunchDamage * DiffScale) / 100;
	if (S.IsA('Titan'))
		Titan(S).PunchDamage = (Titan(S).PunchDamage * DiffScale) / 100;
	if (S.IsA('Krall'))
		Krall(S).StrikeDamage = (Krall(S).StrikeDamage * DiffScale) / 100;
	if (S.IsA('Manta'))
		Manta(S).StingDamage = (Manta(S).StingDamage * DiffScale) / 100;
	if (S.IsA('Mercenary'))
		Mercenary(S).PunchDamage = (Mercenary(S).PunchDamage * DiffScale) / 100;
	if (S.IsA('Skaarj'))
		Skaarj(S).ClawDamage = (Skaarj(S).ClawDamage * DiffScale) / 100;
	if (S.IsA('Pupae'))
		Pupae(S).BiteDamage = (Pupae(S).BiteDamage * DiffScale) / 100;
	if (S.IsA('Queen'))
		Queen(S).ClawDamage = (Queen(S).ClawDamage * DiffScale) / 100;
	if (S.IsA('Slith'))
		Slith(S).ClawDamage = (Slith(S).ClawDamage * DiffScale) / 100;
	if (S.IsA('Warlord'))
		Warlord(S).StrikeDamage = (Warlord(S).StrikeDamage * DiffScale) / 100;
	
	if (S.Shadow == None)
		S.Shadow = Spawn(class'MonsterShadow', S);
}
*/

function AddDefaultInventory( pawn PlayerPawn ) //Screwed
{
	bUseTranslocator = False;
	if (!bStartedHunt || bGameEnded)
		return;
	Super(GameInfo).AddDefaultInventory(PlayerPawn); //Directly in subject, wheeew !!!
}

function ChangeName(Pawn Other, string S, bool bNameChange)
{
	local pawn APlayer;

	if ( Other.PlayerReplicationInfo == None )
		return;

	if ( S == "" )
		return;

	S = left(S,24);
	if (Other.PlayerReplicationInfo.PlayerName~=S)
		return;

	APlayer = Level.PawnList;

	While ( APlayer != None && APlayer.PlayerReplicationInfo != None )
	{
		if ( APlayer.bIsPlayer && (APlayer.PlayerReplicationInfo.PlayerName~=S) )
		{
			if ( Other.PlayerReplicationInfo != None )
				Other.ClientMessage(S$NoNameChange);
			return;
		}
		APlayer = APlayer.NextPawn;
	}
	if (Other.PlayerReplicationInfo != None)
	{
		Other.PlayerReplicationInfo.OldName = Other.PlayerReplicationInfo.PlayerName;
		Other.PlayerReplicationInfo.PlayerName = S;
		if ( bNameChange && !Other.IsA('Spectator') )
			BroadcastLocalizedMessage( DMMessageClass, 2, Other.PlayerReplicationInfo );

		if (LocalLog != None)
			LocalLog.LogNameChange(Other);
		if (WorldLog != None)
			WorldLog.LogNameChange(Other);
	}
}

event InitGame( string Options, out string Error ) //Screwed
{
	local string InOpt, LeftOpt;
	local int i;
	local int pos;

// This lot is a crappy hack to get Tournament mode to work... Hacked from DeathMatchPlus
// - Nelsona - Note: You should hack some Assault and/or CTF codes, options for A.I. are a real mess
// I'll show you some crappy hack right in here, not crappy, just personal manure

// Start timer related problems FIRST
	RemainingTime = 60 * TimeLimit;
	SetGameSpeed(GameSpeed);
//==========
//Section power tweaking
	ConsoleCommand("set SpawnPoint bStatic False");
	ConsoleCommand("set SpawnPoint bNoDelete False");
	DoSpawnfix(); //Now suck well
//	DoTheDirt(); //This is only for my fun - Client will be normal, but my server won't host craps
	ConsoleCommand("set PathNode bStatic False");
	ConsoleCommand("set PathNode bNoDelete False");
	ConsoleCommand("set Inventory bNoDelete False");
	ConsoleCommand("set Inventory bStatic False");
	ConsoleCommand("set Pawn bNoDelete False");
	ConsoleCommand("set Pawn bStatic False");
	ConsoleCommand ("set ScriptedPawn bGameRelevant False"); //Allow me to manage things
	if (bDumbDown)
		ConsoleCommand ("set ScriptedPawn TeamTag@TT");
	ConsoleCommand ("set ScriptedPawn Team 1");
	ConsoleCommand ("set PathNode bPlayerOnly False");
	ConsoleCommand ("set PathNode NetUpdateFrequency 1.000000"); //Less useful updating - is bStatic anyway and cannot be screwed easily
	ConsoleCommand ("set PathNode RemoteRole ROLE_None"); //Really I don't care about that RemoteRole
	ConsoleCommand ("set PathNode bStatic True");
	ConsoleCommand ("set PathNode bNoDelete True");
	ConsoleCommand ("set WarHeadAmmo AmmoAmount 1");
//==========
	Super(GameInfo).InitGame(Options,Error);
	MaxTeams = 2;
	TimeLimit = GetIntOption( Options, "TimeLimit", TimeLimit );
	// Here some byte was set, I'm so glaaaad :D, Yaay !
	//Checking stupid values. Bullshits aren't accepted...
	if (MonsterSkill > 7) MonsterSkill = 7;
	if (MonsterSkill < 1) MonsterSkill = 1; //Not accept 0 value :P.
	if ( MonsterSkill == 1 )
		Difficulty = 0;
	if (MonsterSkill == 2 || MonsterSkill == 3)
		Difficulty = 1;
	if (MonsterSkill == 4 || MonsterSkill == 5)
		Difficulty = 2;
	if (MonsterSkill == 6 || MonsterSkill == 7)
		Difficulty = 3;
/*
These are history, I won't use them anyway, in low gravity a pupae is really stupid
Only a dumbass will use these. Is time to leave things normal.
	for (M = BaseMutator; M != None; M = M.NextMutator)
	{
		if (M.class == class'Botpack.LowGrav')
		{
			last.NextMutator = M.NextMutator;
			M.Destroy();
			M = last;
		}
		if (M.class == class'Botpack.InstaGibDM')
		{
			last.NextMutator = M.NextMutator;
			M.Destroy();
			M = last;
		}
	}
*/
	FragLimit = 0; //LOL. What is for this one ?
	MaxCommanders = 0; //Really ? Need craps ? Where are used these ?
	InOpt = ParseOption( Options, "CoopWeaponMode");
	if ( InOpt != "" ) bCoopWeaponMode = bool(InOpt);
	IDnum = -1;
/*
	IDnum = GetIntOption( Options, "Tournament", IDnum ); //No need this
	if ( IDnum > 0 )
	{
		bRatedGame = true;
		TimeLimit = 0;
		RemainingTime = 0;
	}
*/
	if ( Level.NetMode == NM_StandAlone )
	{
		bRequireReady = true;
		CheckReady();
	}
	if ( Level.NetMode == NM_StandAlone )
	{
		bRequireReady = true;
		CountDown = 1;
	}
	if ( !bRequireReady && (Level.NetMode != NM_Standalone) )
	{
		bRequireReady = true;
		bNetReady = true;
	}
	bJumpMatch = False;
	bNoMonsters = False;
	bNoTeamChanges = True;
	bBalanceTeams = False;
	bPlayersBalanceTeams = False;
	bSpawnInTeamArea = True; //Probably we have great things in here
	bCanChangeSkin = True;	//By default, :P
//	bLocalLog = False;	//Assuming we have a better LogFileClass :|
	bWorldLog = False;	//Bla bla too much talk, keep bandwidth clean because you piss me off.
}

function DoSpawnfix()
{
	local SpawnPoint So, Sn;
	local ThingFactory Tf;
	local int i;

	ForEach AllActors ( class 'UnrealShare.SpawnPoint', So )
	{
		if ( So != None && So.class == class 'UnrealShare.SpawnPoint' )
		{
			Sn = Spawn(class 'MonsterHunt.SpawnPoint',,,So.Location+vect(0,0,1),So.Rotation);
			if ( Sn != None )
			{
//				Log (Sn$" spawned for "$So);
				if (So.Tag != '') Sn.SetPropertyText("Tag",So.GetPropertyText("Tag"));
				if (So.Event != '') Sn.SetPropertyText("Event",So.GetPropertyText("Event"));
				Sn.SetPropertyText("factory",So.GetPropertyText("factory"));
				So.SetPropertyText("Tag",("None"));
//				log (Sn$" new tag is "$Sn.Tag);
//				log ( So.Tag$" is the Tag from "$So);
			}
		}
	}
	ConsoleCommand ("Set PlayerStart bStatic 0");
	ConsoleCommand ("Set PlayerStart bNoDelete 0");
	ConsoleCommand ("Set PlayerStart TeamNumber 0"); //Yeah
	ConsoleCommand ("Set PlayerStart bStatic 1");
	ConsoleCommand ("Set PlayerStart bNoDelete 1");
}

function bool SetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local int i;
	local pawn P, Best;
	local PlayerPawn player;
	local bool bGood;
	local ScriptedPawn S;
	local CreatureCarcass C;
	local ThingFactory T;
	local SpawnPoint SP;

	bGood = True;

	// find individual winner
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
		if ( P.PlayerReplicationInfo != None && ((Best == None) || (P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score)) )
			Best = P;

	if ( Reason == "No Hunters" ) //Is possible to have this if you lost all lives... He, he, can be cheated, :D, :P
	{
		bGood = False;
		GameEndedMessage = "Hunting party eliminated!";
	}

	if ((RemainingTime == 0) && (TimeLimit >= 1))
	{
		bGood = False;
		GameReplicationInfo.GameEndedComments = TimeOutMessage;
	}
	else
		GameReplicationInfo.GameEndedComments = GameEndedMessage;
		EndTime = Level.TimeSeconds + 3.0;

	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		player = PlayerPawn(P);
		if (P != None && P.IsA('ScriptedPawn'))
		{
			ScriptedPawn(P).Enemy = None;
			ScriptedPawn(P).Hated = None;
			ScriptedPawn(P).bHunting = False;
			ScriptedPawn(P).Target = None;
			ScriptedPawn(P).MoveTarget = None;
			P.HidePlayer();
			P.Style = STY_Translucent;
		}
		if (!P.IsA('TournamentPlayer'))
			P.GotoState('GameEnded');
		P.SetLocation(P.Location);
		P.Velocity.X = 0;
		P.Velocity.Y = 0;
		P.Velocity.Z = 0;
		if ( Player != None )
		{
			player.bBehindView = true;
			if ( Player == Best )
				Player.ViewTarget = None;
			else
				Player.ViewTarget = Best;
			if (!bTutorialGame)
				PlayWinMessage(Player, bGood);
			Player.GotoState('GameEnded');
			Player.ClientGameEnded();
		}
	}
	if (!bGarbRemoved)
	{
		log ("Game seems to be ended, destroying garbage pawns and other useless reamining actors...");
		foreach AllActors (class 'CreatureCarcass', C)
		{
			if (C != None && (!C.bStatic && !C.bNoDelete))
			C.GoToState('Corroding','');
		}
		foreach AllActors (class 'ThingFactory', T)
		{
			if (T != None)
			{
				T.MaxItems = 0;
				T.capacity = 0;
				T.GotoState('Finished');
			}
		}
		log ("Junk removed, start computing stats ...");
		CalcEndStats();	//I think next time is your turn to be loved...
		bGarbRemoved = True; //For maps with player and bots under trigger to not repeat craps - also solved Ending trigger
	}
	return true;
}


function PlayStartUpMessage(PlayerPawn NewPlayer)
{
	local int i;
	local color Green, DarkGreen;

	NewPlayer.ClearProgressMessages();

	Green.G = 255;
	Green.B = 128;
	DarkGreen.G = 200;
	DarkGreen.B = 64;

	NewPlayer.SetProgressColor(Green, i);

	NewPlayer.SetProgressMessage(GameName, i++);
	if ( bRequireReady && (Level.NetMode != NM_Standalone) )
	{
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(TourneyMessage, i++);
	}
	else
	{
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(StartUpMessage, i++);
	}

	if ( Level.NetMode == NM_Standalone )
		NewPlayer.SetProgressMessage(SingleWaitingMessage, i++);
}

event playerpawn Login
(
	string Portal,
	string Options,
	out string Error,
	class<playerpawn> SpawnClass
)
{
	local PlayerPawn	NewPlayer, TestPlayer;
	local string		OverrideClass;
	local class<PlayerPawn> SpecClass;
	local string		InVoice;
	local NavigationPoint StartSpot;

	if ( (Level.NetMode != NM_Standalone) && (NumCommanders >= MaxCommanders) && ClassIsChildOf(SpawnClass, class'Commander') )
	{
		Error="Max commanders "$MaxCommanders$" exceeded";
		return None;
	}

	if ( !bRatedGame )
	{
		if ( !bDisallowOverride )
		{
			OverrideClass = ParseOption ( Options, "OverrideClass" );
			if ( OverrideClass != "" )
			{
				SpecClass = class<PlayerPawn>(DynamicLoadObject(OverrideClass,class'Class'));
				if ( (SpecClass != None) && ClassIsChildOf( SpecClass, class'CHSpectator') )
					SpawnClass = SpecClass;
			}
		}
		if ( ClassIsChildOf(SpawnClass, class'Spectator') )
		{
			if ( !ClassIsChildOf( SpawnClass, class'CHSpectator') )
				SpawnClass = class'CHSpectator';
		}
		else if ( !ClassIsChildOf(SpawnClass, class'TournamentPlayer') )
			SpawnClass = DefaultPlayerClass;
	}
	else if ( !ClassIsChildOf(SpawnClass, class'TournamentPlayer') )
		SpawnClass = DefaultPlayerClass;

	NewPlayer = Super(GameInfo).Login(Portal, Options, Error, SpawnClass);

	if ( NewPlayer != None )
	{
		if ( !NewPlayer.IsA('Spectator') )
		{
			InVoice = ParseOption ( Options, "Voice" );
			if ( InVoice != "" )
				NewPlayer.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject(InVoice, class'Class'));
			if ( NewPlayer.PlayerReplicationInfo.VoiceType == None )
				NewPlayer.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject(NewPlayer.VoiceType, class'Class'));
			if ( NewPlayer.PlayerReplicationInfo.VoiceType == None )
				NewPlayer.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject("Botpack.VoiceMaleOne", class'Class'));
		}
		if ( bRatedGame )
			NewPlayer.AirControl = 0.35;
		else
			NewPlayer.AirControl = AirControl;
		if ( Left(NewPlayer.PlayerReplicationInfo.PlayerName, 6) == DefaultPlayerName )
		{
			if (Level.Game.WorldLog != None)
				Level.Game.WorldLog.LogSpecialEvent("forced_name_change", NewPlayer.PlayerReplicationInfo.PlayerName, NewPlayer.PlayerReplicationInfo.PlayerID, DefaultPlayerName$NumPlayers);
			ChangeName( NewPlayer, (DefaultPlayerName$NumPlayers), false );
		}
		NewPlayer.bAutoActivate = True;
		if ( (bGameEnded || (bRequireReady && (CountDown > 0))) && !NewPlayer.IsA('Spectator') )
			NewPlayer.PlayerRestartState = 'PlayerWaiting';
		else
			NewPlayer.PlayerRestartState = NewPlayer.Default.PlayerRestartState;

		if ( NewPlayer.IsA('TournamentPlayer') )
		{
			TournamentPlayer(NewPlayer).StartSpot = LastStartSpot;
			if ( NewPlayer.IsA('Commander') )
				NumCommanders++;
		}
	}

	// Section TeamGamePlus almost totally skipped
	if ( newPlayer == None)
		return None;

		PlayerTeamNum = NewPlayer.PlayerReplicationInfo.Team;
	if (bUseLives)	//Grr, continue to piss me off...
		if ( (NewPlayer != None) && !NewPlayer.IsA('Spectator') )
			NewPlayer.PlayerReplicationInfo.Deaths = MonsterReplicationInfo(GameReplicationInfo).Lives;
	CountHunters();	//Yea, buy a counter, I think we have already some NumPlayers at gameinfo but... heck.
	return newPlayer;
}

function bool RestartPlayer( pawn aPlayer )
{
	local NavigationPoint startSpot;
	local bool foundStart;
	local Pawn P;

	if (MonsterReplicationInfo(GameReplicationInfo).bUseLives) //No really comment, um, oh, yes - retarded option
	{
		if( bRestartLevel && Level.NetMode!=NM_DedicatedServer && Level.NetMode!=NM_ListenServer )
			return true;

		if ( aPlayer.PlayerReplicationInfo.Deaths < 1 )
		{
			BroadcastMessage(aPlayer.PlayerReplicationInfo.PlayerName$" has been lost!", true, 'MonsterCriticalEvent');
			For ( P=Level.PawnList; P!=None; P=P.NextPawn )
			{
				if (!P.bIsPlayer || P.PlayerReplicationInfo == None)
					continue;
				if ( P.bIsPlayer && (P.PlayerReplicationInfo.Deaths >= 1) ) //Only a loser is lost, a smart one is not lost :P
					P.PlayerReplicationInfo.Deaths += 0.00001;
			}
			if ( aPlayer.IsA('Bot') )
			{
				aPlayer.PlayerReplicationInfo.bIsSpectator = true;
				aPlayer.PlayerReplicationInfo.bWaitingPlayer = true;
				aPlayer.GotoState('GameEnded');
				return false;
			}
		}
		startSpot = FindPlayerStart(None, 255);
		if( startSpot == None )
			return false;
		foundStart = aPlayer.SetLocation(startSpot.Location);
		if( foundStart )
		{
			startSpot.PlayTeleportEffect(aPlayer, true);
			aPlayer.SetRotation(startSpot.Rotation);
			aPlayer.ViewRotation = aPlayer.Rotation;
			aPlayer.Acceleration = vect(0,0,0);
			aPlayer.Velocity = vect(0,0,0);
			aPlayer.Health = aPlayer.Default.Health;
			aPlayer.ClientSetRotation( startSpot.Rotation );
			aPlayer.bHidden = false;
			aPlayer.DamageScaling = aPlayer.Default.DamageScaling;
			aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
			if ( aPlayer.PlayerReplicationInfo.Deaths < 1 )
			{
				aPlayer.bHidden = true;
				aPlayer.PlayerRestartState = 'PlayerSpectating';
			} 
			else
			{
				aPlayer.SetCollision( true, true, true );
				if ( bStartedHunt )
					AddDefaultInventory(aPlayer);
			}
		}
		return foundStart;
	}
	else 
		return Super.RestartPlayer(aPlayer);
	CountHunters();
}

function NavigationPoint FindPlayerStart( Pawn Player, optional byte InTeam, optional string incomingName )
{
	local PlayerStart Dest, Candidate[32], Best;
	local float Score[32], BestScore, NextDist;
	local pawn OtherPlayer;
	local int i, num;
	local Teleporter Tel;
	local NavigationPoint N;
	local byte Team;

	Team = 0;

	if ( bStartMatch && (Player != None) && Player.IsA('TournamentPlayer') 
		&& (Level.NetMode == NM_Standalone)
		&& (TournamentPlayer(Player).StartSpot != None) )
		return TournamentPlayer(Player).StartSpot;

	if ( (Player != None) && (Player.PlayerReplicationInfo != None) )
		Team = Player.PlayerReplicationInfo.Team;
	else
		Team = InTeam;

	if( incomingName!="" )
		foreach AllActors( class 'Teleporter', Tel )
			if( string(Tel.Tag)~=incomingName )
				return Tel;

	if ( Team == 255 || Team != 0 )
		Team = 0;

	//choose candidates
	num = 0;
	for ( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
	{
		Dest = PlayerStart(N);
		if ( (Dest != None) && Dest.bEnabled
			&& (!bSpawnInTeamArea || (Team == Dest.TeamNumber)) )
		{
			if (num<32)
				Candidate[num] = Dest;
			else if (Rand(num) < 32)
				Candidate[Rand(32)] = Dest;
			num++;
		}
	}

	if (num == 0 ) //Lol ?
	{
//		log("Playerstart for team"@Team@"not found !");
		foreach AllActors( class'PlayerStart', Dest )
		{
			if (num < 32)
				Candidate[num] = Dest;
			else if (Rand(num) < 32)
				Candidate[Rand(32)] = Dest;
			num++;
		}
		if ( num == 0 )
			return None;
	}
	if (num > 32) 
		num = 32;
	//assess candidates
	for (i=0;i<num;i++)
	{
		if ( Candidate[i] == LastStartSpot )
			Score[i] = -6000.0;
		else
			Score[i] = 4000 * FRand(); //randomize
	}
	
	for ( OtherPlayer=Level.PawnList; OtherPlayer!=None; OtherPlayer=OtherPlayer.NextPawn)	
	{
	if ( !OtherPlayer.bIsPlayer || OtherPlayer.PlayerReplicationInfo == None)
		continue;
	if ( OtherPlayer.bIsPlayer && (OtherPlayer.Health > 0) && !OtherPlayer.IsA('Spectator') && OtherPlayer.PlayerReplicationInfo != None )
			for (i=0; i<num; i++)
				if ( OtherPlayer.Region.Zone == Candidate[i].Region.Zone ) 
				{
					Score[i] -= 1500;
					NextDist = VSize(OtherPlayer.Location - Candidate[i].Location);
					if (NextDist < 2 * (CollisionRadius + CollisionHeight))
						Score[i] -= 1000000.0;
					else if ( (NextDist < 2000) && (OtherPlayer.PlayerReplicationInfo.Team != Team)
							&& FastTrace(Candidate[i].Location, OtherPlayer.Location) )
						Score[i] -= (10000.0 - NextDist);
				}
	}
	BestScore = Score[0];
	Best = Candidate[0];
	for (i=1; i<num; i++)
		if (Score[i] > BestScore)
		{
			BestScore = Score[i];
			Best = Candidate[i];
		}
	LastStartSpot = Best;
	return Best;
}

function bool IsOnTeam(Pawn Other, int TeamNum)	//Added
{
	if ( Other.bIsPlayer && Other.PlayerReplicationInfo != None
	&& Other.PlayerReplicationInfo.Team == TeamNum )
		return true;
	return false;
}

function SetBotOrders(Bot NewBot)
{
	local Pawn P, L;
	local int num, total;

	NewBot.bJumpy = True;
	NewBot.BaseAggressiveness = NewBot.Default.BaseAggressiveness+0.3;
	if ( IsOnTeam(NewBot,0) )
	{
		NewBot.SetOrders('Freelance', None, true);
		return;
	}
}

function CheckEndGame()
{
	local Pawn PawnLink;
	local int StillPlaying;
	local bool bStillHuman;
	local bot B, D;

	if ( bGameEnded )
		return;

	LivePpl = 0;
	PlainPpl = 0;
	for ( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.nextPawn )
		if ( PawnLink.bIsPlayer && PawnLink.PlayerReplicationInfo != None )
		{
			if ( ( PawnLink.PlayerReplicationInfo.Deaths >= 1 ) && 
				!PawnLink.PlayerReplicationInfo.bIsSpectator )
				LivePpl ++;
			if ( PawnLink.IsA('PlayerPawn') &&
				(PawnLink.PlayerReplicationInfo.Deaths >= 1) )
				PlainPpl ++;
		}

	if ( LivePpl < 1 )
		EndGame("No Hunters");
	else if ( PlainPpl < 1 )
	{
		for ( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn )
		{
			B = Bot(PawnLink);
			if ( (B != None) && (B.Health > 0) )
				B.SetOrders('FreeLance', None,true);
		}
	}
}

function Killed( pawn killer, pawn Other, name damageType )
{
	local Projectile Pr;

	if ( Other == None )
		return;
	//==============
	if (Other.PlayerReplicationInfo == None)
	{
		foreach AllActors (class 'Projectile', Pr)
		{
			if ( Pr != None && Pr.Instigator == Other )
			{
				Pr.bReplicateInstigator = False;
				Pr.Instigator = None;
				Pr.Destroy();
			}
		}
	}
	if (Other.Spree > 0) Other.Spree = 0;
	//==============
	if ( Killer != None )
	{
		if ( Killer.PlayerReplicationInfo != None )
		{
			if ( !bFirstBlood )
			{
				if ( Killer != Other )
				{
					bFirstBlood = True;
					BroadcastLocalizedMessage( class'FirstBloodMessage', 0, Killer.PlayerReplicationInfo );
				}
				bFirstBlood = True;
			}
			if ( (damageType == 'Decapitated') && (Killer != Other) )
			{
				if (Level.Game.LocalLog != None && Other.PlayerReplicationInfo != None )
					Level.Game.LocalLog.LogSpecialEvent("headshot", Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID);
				if (Level.Game.WorldLog != None && Other.PlayerReplicationInfo != None )
					Level.Game.WorldLog.LogSpecialEvent("headshot", Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID);
				Killer.ReceiveLocalizedMessage( class'DecapitationMessage' );
			}
			if ( Killer == Other && Other.PlayerReplicationInfo != None )
				Other.PlayerReplicationInfo.Score -= 4;
		}
		if ( Other.PlayerReplicationInfo == None && Killer != Other )
		{
			BroadcastMessage(Killer.GetHumanName()@"killed"@Other.GetHumanName());
			if (Killer.PlayerReplicationInfo == None)
				return;
		}
		if ( Killer.PlayerReplicationInfo == None )
		{
			if ( Other.PlayerReplicationInfo != None && !MonsterReplicationInfo(GameReplicationInfo).bUseLives )
			{
				Other.PlayerReplicationInfo.Score -= 5;
			}
			if ( Other.PlayerReplicationInfo == None )
			{
				if (Killer == Other)
					BroadcastMessage(Killer.GetHumanName()@"killed itself.");
				return;
			}
		}
	}
	else
	{
		if ( Other.PlayerReplicationInfo == None )
		{
			BroadcastMessage(Other.GetHumanName()@"died.");
			if ( ScriptedPawn(Other) != None );
				ScriptedPawn(Other).SpawnGibbedCarcass();
			Other.Destroy();
			return;
		}
		
	}
	if ( Other.bIsPlayer && Other.PlayerReplicationInfo != None && MonsterReplicationInfo(GameReplicationInfo).bUseLives )
	{
		if ( Killer == None || ( Killer != None && Killer == Other ) || ( Killer != None && Killer.PlayerReplicationInfo != None && Killer != Other ) )
			Other.PlayerReplicationInfo.Deaths -= 2;
		else
		{
			Other.PlayerReplicationInfo.Deaths -= 1;
			Other.PlayerReplicationInfo.Score -= 5;
		}
	}
	if ( MonsterReplicationInfo(GameReplicationInfo).bUseLives && Other.bIsPlayer && Other.PlayerReplicationInfo != None )
		CheckEndGame();
	if ( DamageType == 'SpecialDamage' ) //EHEH
	{
		BroadcastMessage(Other.GetHumanName()@"died.");
		return;
	}
	Super(GameInfo).Killed(Killer, Other, damageType);
}

function ScoreKill(pawn Killer, pawn Other)
{
	local ScriptedPawn S;
	local int ph;

	if ( Killer != None && Killer.PlayerReplicationInfo == None ) return;
	if ( Other.IsA('ScriptedPawn') )
	{
		S = ScriptedPawn(Other);
		if ( S != None )
			ph = S.Default.Health;
	}
	if ( ( Killer != None && Killer.PlayerReplicationInfo != None ) && S != None )
	{
		if (S.IsA('Nali') || S.IsA('Cow'))
			Killer.PlayerReplicationInfo.Score += 0.02*ph;
		else if (S.bIsBoss)
			Killer.PlayerReplicationInfo.Score += 0.06*ph;
		else
			Killer.PlayerReplicationInfo.Score += 0.04*ph;
		Killer.KillCount++;
		return;
	}
	if (!Other.IsA('ScriptedPawn')) return;
	Super(DeathMatchPlus).ScoreKill(Killer, Other);

//=============
// Score depending on which monster type the player kills
/*
	if ( (Killer.bIsPlayer) && ( (Other.IsA('Titan')) || (Other.IsA('Queen')) || (Other.IsA('WarLord')) ) )
		Killer.PlayerReplicationInfo.Score += 4;
	if ( (Killer.bIsPlayer) && ( (Other.IsA('GiantGasBag')) || (Other.IsA('GiantManta')) ) )
		Killer.PlayerReplicationInfo.Score += 3;
	if ( (Killer.bIsPlayer) && ( (Other.IsA('SkaarjWarrior')) || (Other.IsA('MercenaryElite')) || (Other.IsA('Brute')) ) )
		Killer.PlayerReplicationInfo.Score += 2;
	if ( (Killer.bIsPlayer) && ( (Other.IsA('SkaarjTrooper')) || ( (Other.IsA('Mercenary')) && (!Other.IsA('MercenaryElite')) ) || (Other.IsA('Krall')) || (Other.IsA('Slith')) || ( (Other.IsA('GasBag')) && (!Other.IsA('GiantGasBag')) ) ) )
		Killer.PlayerReplicationInfo.Score += 1;

	// Lose points for killing innocent creatures. Shame ;-)
	if ( (Killer.bIsPlayer) && ( (Other.IsA('Nali')) || (Other.IsA('Cow')) || (Other.IsA('NaliRabbit')) ) )
		Killer.PlayerReplicationInfo.Score -= 6;

	// Get 10 extra points for killing the boss!!
*/
}

function CountMonsters()
{
	local ScriptedPawn S;
	local Pawn P;

	MonstersTotal = 0;

	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		S = ScriptedPawn(P);
		if ( S != None )
		{
			if ( S.Health >= 1 )
			{
				MonstersTotal++;
				if (bDumbDown)
					if ( !S.IsA('Nali') && !S.IsA('Cow') )
						S.TeamTag = TT;
			}
			if ( S.Health < 0 )
			if ( !S.IsInState('Dying') )
			{
				S.SpawnGibbedCarcass();
				S.Destroy();
			}
		}
	}
/*
	foreach AllActors(class'ScriptedPawn', S)
	{
		if ( S != None && S.Health >= 1 )
		{
			MonstersTotal++;
			if (bDumbDown)
				if ( !S.IsA('Nali') && !S.IsA('Cow') )
					S.TeamTag = TT;
		}
		if (S != None && S.Health < 0)
		{
			S.Destroy();
		}
	}
*/
	MonsterReplicationInfo(GameReplicationInfo).Monsters = MonstersTotal;
}

event PostLogin( playerpawn NewPlayer )
{
	Super(DeathMatchPlus).PostLogin(NewPlayer);

/*
	if ( Level.NetMode != NM_Standalone ) //LOLZ to red color
		NewPlayer.ClientChangeTeam(NewPlayer.PlayerReplicationInfo.Team);
*/
}

function AddToTeam( int num, Pawn Other )
{
	local teaminfo aTeam;
	local Pawn P;
	local bool bSuccess;
	local string SkinName, FaceName;

	if ( Other != None )
	{
		aTeam = Teams[0];
		aTeam.Size++;
		Other.PlayerReplicationInfo.Team = 0;
		Other.PlayerReplicationInfo.TeamName = aTeam.TeamName;
		bSuccess = false;
		if ( Other.IsA('PlayerPawn') )
		{
			Other.PlayerReplicationInfo.TeamID = 0;
			PlayerPawn(Other).ClientChangeTeam(Other.PlayerReplicationInfo.Team);
		}
		else
			Other.PlayerReplicationInfo.TeamID = 1;

		while ( !bSuccess )
		{
			bSuccess = true;
			for ( P=Level.PawnList; P!=None; P=P.nextPawn )
			{
				if ( P.PlayerReplicationInfo == None )
					continue;
				if ( P.bIsPlayer && (P != Other) 
					&& (P.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team) 
					&& (P.PlayerReplicationInfo.TeamId == Other.PlayerReplicationInfo.TeamId) )
				{
					Other.PlayerReplicationInfo.TeamID++;
					bSuccess = False;
				}
			}
		}

		if (MonsterReplicationInfo(GameReplicationInfo).bUseLives)
			Other.PlayerReplicationInfo.Deaths = MonsterReplicationInfo(GameReplicationInfo).Lives;

		if (MonsterReplicationInfo(GameReplicationInfo).bUseTeamSkins)
		{
			Other.static.GetMultiSkin(Other, SkinName, FaceName);
			Other.static.SetMultiSkin(Other, SkinName, FaceName, 0);
		}
	}
}

function StartMatch()
{
	local ScriptedPawn S;
	local Pawn P;
	local Weapon W, W1;

	foreach AllActors(class'ScriptedPawn', S)
	{
		if ( !S.IsA('Nali') && !S.IsA('Cow') /*&& !S.IsA('NaliRabbit')*/)
			S.AttitudeToPlayer=ATTITUDE_Frenzy;
	}
	foreach AllActors(class 'ScriptedPawn', S)
	{
		if ( S != None && S.Weapon != None )
		{
			W=S.Weapon;
			W1 = Spawn(W.class,S,,S.Location,S.Rotation);
			if ( W1 != None )
			{
				S.Weapon = None;
				W.Instigator=None;
				W.Destroy();
				W1.ReSpawnTime = 0.0;
				W1.bHeldItem=True;
				W1.Instigator=S;
				W1.BecomeItem(); //Do not mess anims
				S.AddInventory(W1);
				W1.GiveAmmo(S);
				W1.WeaponSet(S);
			}
		}
	}
	bStartedHunt = True;
	super.StartMatch();
}

function ShowAquiredData() //Data and boolean might be screwed by mutator if information is requested
{
	if ( MsgTmr == 1 )
		BroadcastMessage("Verbose mode is ON.",True,'InfoEventPlus');
	if ( MsgTmr == 3 )
	{
		if ( EndWarn == 0 )
			BroadcastMessage("This map doesn't have a correct ending. May have teleporter to next map?",True,'InfoEventPlus');
		if ( EndWarn > 9 )
			BroadcastMessage("This map might be a little retarded with "$EndWarn$" Ends.",True ,'InfoEventPlus');
	}
	if ( MsgTmr == 7)
	{
		if ( PathWarn <= 1 )
			BroadcastMessage("This map has few PathNodes - Bot Support will be poor.",True ,'InfoEventPlus');
		if ( PathWarn >= 2 )
			BroadcastMessage("This map includes "$PathWarn$" PathNodes. More is generally better.",True ,'InfoEventPlus');
	}
	if ( MsgTmr >= 11 && MsgTmr < 15)
	{
		if ( WaysCnt == 0 && MsgTmr == 11)
			BroadcastMessage("This map doesn't include any WayPoints.",True,'InfoEventPlus');
		if ( WaysCnt == 0 && PathWarn > 20 && MsgTmr == 13 )
			BroadcastMessage("Bot Support might be simple or missing. We have "$PathWarn$" PathNodes but not WayPoints.",True ,'InfoEventPlus');
		if ( WaysCnt > 0 && PathWarn > 20 && MsgTmr == 11)
			BroadcastMessage("This map includes "$WaysCnt$" WayPoints - Bot Support might be functional.",True ,'InfoEventPlus');
	}
	if ( MsgTmr == 15 )
	{
		if ( WepCnt == 0 )
			BroadcastMessage("Warning: This map has few weapon pickups. You might need another mod to supply weapons.",True,'InfoEventPlus');
		if ( WepCnt > 0 )
			BroadcastMessage("The number of Weapons from map = "$WepCnt$".",True,'InfoEventPlus');
	}
	if ( MsgTmr == 19 )
	{
		if ( MovFix == 0 )
			BroadcastMessage("In this map we did not need to adjust any Movers.",True ,'InfoEventPlus');
		if ( MovFix > 0 )
			BroadcastMessage("The number of tweaks done to Movers = "$MovFix$".",True ,'InfoEventPlus');
	}
	if ( MsgTmr == 23 )
	{
		if (PawnFix == 0)
			BroadcastMessage("In this map we did not need to adjust any Monsters.",True ,'InfoEventPlus');
		if (PawnFix > 0)
			BroadcastMessage("The number of tweaks done to Monsters = "$PawnFix$".",True ,'InfoEventPlus');
	}
	if ( MsgTmr == 27 )
	{
		if ( FactFix == 0 )
			BroadcastMessage("In this map we did not need to adjust any Factories.",True ,'InfoEventPlus');
		if ( FactFix > 0 )
			BroadcastMessage("The number of tweaks done to Factories = "$FactFix$".",True ,'InfoEventPlus');
	}
	MsgTmr++;
	if ( MsgTmr >= 32 )
	{
		BroadcastMessage("  ",True,'InfoEventPlus');
		bAbleToInfo = False;
	}
}

function Timer() //Screwed - just skip Domination chapter
{
	if ( !bGameEnded ) //Don't move MH related things if game is over
	{
		CT++;
		if (CT >= 3)
		{
			CT = 0;
			CountHunters();
			CountMonsters();
		}
		if ( bAbleToInfo )
		{
			if ( bStartedHunt )
				ShowAquiredData();
		}
	}
	Super(DeathMatchPlus).Timer(); //let DeathMatchPlus to manage travel and others
}
/*
function Timer()
{
	CountHunters();
	Super.Timer();
}
*/

function CountHunters()
{
	local Pawn P;
	local TournamentPlayer T;
	local Bot B;

	HuntersTotal = 0;

	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		T = TournamentPlayer(P);
		B = Bot(P);

		if ( T != None && !T.PlayerReplicationInfo.bIsSpectator )
			HuntersTotal++;
		if ( B != None && !B.PlayerReplicationInfo.bIsSpectator )
		{
			if ( B.Region.Zone.bWaterZone && B.Physics != PHYS_Swimming )
				B.SetPhysics(PHYS_Swimming);
			HuntersTotal++;
		}
	}
/*
	foreach AllActors(class'TournamentPlayer', P)
	{
		if (!P.PlayerReplicationInfo.bIsSpectator)
			HuntersTotal ++;
	}
	foreach AllActors(class'Bot', B)
	{
		if (!B.PlayerReplicationInfo.bIsSpectator)
			HuntersTotal ++;
	}
*/
	MonsterReplicationInfo(GameReplicationInfo).Hunters = HuntersTotal;
}

function bool FindSpecialAttractionFor(Bot aBot)
{
	local MonsterWaypoint W;
	local MonsterEnd E;
	local MonsterWaypoint NextPoint;
	local Weapon We;
	local bool bFound, foundtarget, bLockedAndLoaded;
	local ScriptedPawn S;
	local NavigationPoint N;
	local Pawn P;
	local name Stt;

//	log("Attraction called by "$aBot.GetHumanName()$" in state "$aBot.GetStateName());
	if ( aBot.Health < 1 )
	{
//		log("Bork #1");
		aBot.GotoState('GameEnded');
		return false;
	}
	if ( abot.Health > 2 && !aBot.bHidden )
	{
//		log ("Bork #2");
		if ( aBot.Weapon == None && aBot.PlayerReplicationInfo.Team == 0 )
			RestartPlayer(aBot);

		if ( aBot.Region.Zone.bWaterZone )
		{
			if ( aBot.Physics != PHYS_Swimming )
				aBot.SetPhysics(PHYS_Swimming);
		}
	}
	if ( aBot.LastAttractCheck == Level.TimeSeconds )
		return false;
	aBot.LastAttractCheck = Level.TimeSeconds;
/*
	Are you kidding ?
	Who calls this if Bot is missing ?
	if(aBot==None)
		return false;
*/

	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		S = ScriptedPawn(P);
		if ( S != None && S.Health > 0 )
		{
			if ( !FastTrace(S.Location,aBot.Location )) continue;//{}
//				else
			if ( S.LineOfSightTo(aBot) && ValidSight(S,aBot) )
			{
				Stt = S.GetStateName();
				if ( Stt != 'Sitting' || Stt != 'Teleporting')
				{
					if ( S.Enemy == None || ( S.Enemy != None && ( !S.LineOfSightTo( S.Enemy )
					|| (  VSize(S.Enemy.Location - S.Location) > VSize(S.Location-aBot.Location ) && FRand() > 0.6 ))))
					{
						S.Hated = aBot;
						S.Enemy = aBot;
						S.LastSeenPos = aBot.Location;
						S.Target = aBot;
						S.GotoState('Attacking');
						if ( aBot.Enemy == None || ( aBot.Enemy != None && !aBot.LineOfSightTo(aBot.Enemy)))
							aBot.Enemy = S;
						if (!aBot.IsInState('Attacking'))
						{
							aBot.GotoState('Attacking');
//							return false;
						}
					}
				}
			}
		}
	
	}
	if ( aBot.Enemy == None || (aBot.Enemy != None && !aBot.LineOfSightTo(aBot.Enemy)))
	{
//		log ("Test telefragging by "$aBot.GetHumanName());
		for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
		{
			if ( N != None && VSize(N.Location-aBot.Location) > 600 ) continue;
			if ( N != None && N.IsA('Teleporter')
			&& Teleporter(N).bEnabled
			&& FastTrace(aBot.Location,N.Location)
			&& Teleporter(N).URL != "" )
			{
				for (P=Level.PawnList; P!=None; P=P.NextPawn)
				{
					if (P != None && P == aBot ) continue;
					if ( P != None && P.PlayerReplicationInfo != None )
					{
//						log ("aPawn has "$VSize(N.Location - P.Location));
//						log ("Attractor "$aBot.GetHumanName()$" has "$VSize(N.Location - aBot.Location));
						if ( VSize(P.Velocity) > 100 && aBot.MoveTarget != None
						&& VSize(N.Location - P.Location) < VSize( N.Location-aBot.Location )
						&& FastTrace(N.Location,P.Location)
						&& VSize( N.Location-aBot.Location ) < 600 )
						{
							aBot.MoveTarget = None;
							aBot.Acceleration = vect(0,0,0);
							aBot.CampTime = 1.0;
							aBot.GotoState('Roaming', 'Camp');
							if (aBot.bVerbose)
								log ("Attempt to stop "$aBot.GetHumanName()$" from telefragging "$P.GetHumanName());
							return False;
						}
					}
				}
			}
		}
	}

	if ( aBot.Enemy != None && ValidSight(aBot.Enemy,aBot) && FRand() > 0.5 )
	{
		aBot.Target = aBot.Enemy;
		if (!aBot.IsInState('Attacking'))
		{
			aBot.GotoState('Attacking');
			return false;
		}
	}

	if ( aBot.IsInState('Fallback') )
		return False;
//Condition to Not hunt without power or... Kamikaze
	bLockedAndLoaded = ( aBot.Weapon != None && ( ( aBot.Weapon.AIRating >= 0.2 && aBot.Health > 30 ) || aBot.Health > 160 ) );
//Try to get something around first

	if ( !bLockedAndLoaded )
	{
		if ( FRand() > 0.6 )
			return False;
	}
	else
	{
	if ( ( aBot.Enemy == None ) || ( aBot.Enemy != None && !ValidSight(aBot.Enemy,aBot) ) )
	{
		if ( aBot.Orders == 'Freelance' || ( aBot.Orders == 'Attack' && FRand() > 0.15) ) //Reversed
		{
			if ( MHTarget == None ) //if doesn't exist a target sort one
			{
	//			log ("For the moment no target exists.");
				if ( NumPoints > 0 )
				{
					foreach AllActors( class 'MonsterWayPoint', W )
					{
						if (!W.bVisited && (W.Position == LastPoint + 1))
						{
							NextPoint = W;
							MHTarget = NextPoint;
							NumPoints--;
							foundtarget = True;
						}
					}
				}
				if (!foundtarget)
				{
					foreach AllActors (class 'MonsterEnd', E)
					{
						if ( E != None && !foundtarget)
						{
							MHTarget = E;
							foundtarget = True;
						}
					}
				}
				foundtarget = False;
			}
			if ( MHTarget != None )
			{
				if ( MHTarget.IsA('MonsterEnd') )
				{
					if ( VSize( MHTarget.Location - aBot.Location ) < 40 )
					{
						aBot.CampTime = 1.0;
						aBot.GotoState('Roaming', 'Camp');
					}
				}
				if ( MHTarget.IsA('MonsterWayPoint') )
				{
					if ( VSize( MHTarget.Location - aBot.Location ) < 40 )
					{
						return False;
					}
				}
				if ( aBot.ActorReachable(MHTarget) )
				{
					aBot.RoamTarget = MHTarget;
					aBot.MoveTarget = MHTarget;
					bFound = ( aBot.MoveTarget != None );
				}
				else
				{
					aBot.RoamTarget = MHTarget;
					aBot.MoveTarget = aBot.FindPathTo/*ward*/(MHTarget.Location);
					bFound = ( aBot.MoveTarget != None );
				}
				if ( bFound )
				{
					if ( aBot.Enemy != None )
						aBot.bReadyToAttack = true;
					SetAttractionStateFor(aBot);
					return true;
				}
				else
				{
					if ( PointToTarget == None)
					{
						if ( MHTarget.IsA('MonsterWayPoint') && MonsterWayPoint(MHTarget).MyPoint != None )
						{
							PointToTarget = MonsterWayPoint(MHTarget).MyPoint;
						}
					}
					else
					{
						if ( VSize( PointToTarget.Location - aBot.Location ) < 30 )
						{
							aBot.Target = MHTarget;
							aBot.RoamTarget = MHTarget;
							aBot.MoveTarget = MHTarget;
							aBot.MoveTimer = 1.0;
						}
						else
							if ( aBot.ActorReachable(PointToTarget)
							/*&& !FastTrace(aBot.Location,MHTarget.Location)*/
							&& aBot.Target != MHTarget )
								aBot.MoveTarget = PointToTarget;
							else
								aBot.MoveTarget = aBot.FindPathToward(PointToTarget);
							bFound = ( aBot.MoveTarget != None );
							if ( bFound )
							{
								if ( aBot.Enemy != None )
									aBot.bReadyToAttack = true;
								SetAttractionStateFor(aBot);
							return true;
							}
					}
				}
			}
		}
	}
	}
	return false;
}

function bool ValidSight(Actor S,Bot aBot)
{
	local bool result;
	local actor HitActor;
	local vector HitLocation, HitNormal;

	result=False;
	if ( S == None || aBot == None )
		result=False;
	HitActor = Trace(HitLocation, HitNormal, S.Location, aBot.Location, false);
	if ( HitActor == None )
		result = True;
	return result;
}

function float GameThreatAdd(Bot aBot, Pawn Other) //Added
{
	local float Threaten;
	local bool bPowerThreat;
	Threaten = 0;
	if ( Other.IsA('ScriptedPawn') && ScriptedPawn(Other).Event != '' )
	{
		Threaten = 10;
		bPowerThreat = True;
	}
	if (!bPowerThreat)
	{
		if ( Other.IsA('ScriptedPawn') && !Other.IsA('Cow') && !Other.IsA('Nali') && Other.Health > 0)
			Threaten = FClamp(3000/VSize(Other.Location-aBot.Location),1,10);
	}
	if ( Other.IsA('TeamCannon') || (Other.Location.Z - aBot.Location.Z > 500) )
		Threaten = -1;

//	log ("Game threat for "$aBot.GetHumanName()$" is "$Threaten$ " at "$Other.GetHumanName());
	return Threaten;
}

function byte PriorityObjective(Bot aBot) //Added
{
	local ScriptedPawn S;

	if ( aBot.Weapon != None )
	{
		if ( aBot.Weapon.AIRating < 0.3 )
			return -1;
		else
			return 2;
	}
	return 0;
}

function byte AssessBotAttitude(Bot aBot, Pawn Other)	//Added
{
	local name MState;

	MState=Other.GetStateName();

	if (!ValidSight(Other,aBot) || MState == 'Sitting')
		return 2;
	else if ( ValidSight(Other,aBot) && MState != 'Sitting')
	{
		if ( ( Other.bIsPlayer && Other.PlayerReplicationInfo != None && Other.PlayerReplicationInfo.Team == aBot.PlayerReplicationInfo.Team ) || Other.IsA('Nali') || Other.IsA('Cow') )
			return 3;
		if ( Other.IsA('TeamCannon') && TeamCannon(Other).MyTeam==0 )
			return 3;
		if ( !Other.bIsPlayer && Other.CollisionHeight < 75 )
			return 1;
		if ( !Other.bIsPlayer && Other.CollisionHeight >= 75 )
			return 0;
	}
	else return super(DeathMatchPlus).AssessBotAttitude(aBot, Other);
}

function int ReduceDamage(int Damage, name DamageType, pawn injured, pawn instigatedBy) //screwed properly
{
	Local ScriptedPawn S;

	if (injured.Region.Zone.bNeutralZone)
		return 0;

	if ( instigatedBy == None)
		return Damage;

	if ( bHardCoreMode ) //THIS IS THE ONLY REASON NOT GAME-SPEED
		Damage *= 1.5;

	Damage *= InstigatedBy.DamageScaling;
	if ( bNoviceMode && !bThreePlus )
	{
		if ( instigatedBy.bIsPlayer && instigatedby.PlayerReplicationInfo != None && (injured == instigatedby) && (Level.NetMode == NM_Standalone) )
			Damage *= 0.5;

		//skill level modification
		if ( instigatedBy.IsA('Bot') && injured.IsA('PlayerPawn') )
		{
			if ( ((instigatedBy.Weapon != None) && instigatedBy.Weapon.bMeleeWeapon) 
				|| ((injured.Weapon != None) && injured.Weapon.bMeleeWeapon && (VSize(injured.location - instigatedBy.Location) < 600)) )
				Damage = Damage * (0.76 + 0.08 * instigatedBy.skill);
			else
				Damage = Damage * (0.25 + 0.15 * instigatedBy.skill);
		}
	}
	if ( InstigatedBy != None && injured != None && injured != InstigatedBy && injured.Health > 0 && injured.IsA('ScriptedPawn') && !InstigatedBy.IsA('ScriptedPawn') )
	{
		ScriptedPawn(injured).Hated = InstigatedBy;
		if (FRand() > 0.6)
		{
			ScriptedPawn(injured).Enemy = InstigatedBy;
			ScriptedPawn(injured).LastSeenPos = InstigatedBy.Location;
			ScriptedPawn(injured).Target = InstigatedBy;
			if (bDumbDown)
			foreach ScriptedPawn(injured).RadiusActors (class'ScriptedPawn',S,600)
			{
				if (S != None && S.Health > 0 && (FastTrace(injured.Location,S.location)))
				{
					if (S.IsInState('Waiting') || S.IsInState('Wandering'))
					{
						S.Hated = InstigatedBy;
						S.Enemy = InstigatedBy;
						S.LastSeenPos = InstigatedBy.Location;
						S.GotoState('Attacking');
					}
				}
			}
		}
	}
	if (bDumbDown)
	{
		if (InstigatedBy != None && injured != None && injured != InstigatedBy && injured.Health > 0 && InstigatedBy.Isa('ScriptedPawn') && injured.IsA('ScriptedPawn'))
		{
			if (ScriptedPawn(injured).Enemy != None && ScriptedPawn(injured).Enemy == ScriptedPawn(InstigatedBy))
			{
				if ( ScriptedPawn(InstigatedBy).Enemy != None && !ScriptedPawn(InstigatedBy).Enemy.IsA('ScriptedPawn') )
				{
					ScriptedPawn(injured).Hated = ScriptedPawn(InstigatedBy).Enemy;
					ScriptedPawn(injured).Enemy = ScriptedPawn(InstigatedBy).Enemy;
					ScriptedPawn(injured).LastSeenPos = ScriptedPawn(InstigatedBy).Enemy.Location;
					ScriptedPawn(injured).Target = ScriptedPawn(InstigatedBy).Enemy;
				}
				else
				{
					ScriptedPawn(injured).Hated = None;
					ScriptedPawn(injured).Enemy = None;
					ScriptedPawn(injured).bHunting = False;
					ScriptedPawn(injured).Target = None;
					ScriptedPawn(injured).StartRoaming();
				}
			}
			if (ScriptedPawn(injured).OldEnemy != None && ScriptedPawn(injured).OldEnemy.IsA('ScriptedPawn'))
				ScriptedPawn(injured).OldEnemy = None;
			if (ScriptedPawn(InstigatedBy).Enemy != None && ScriptedPawn(InstigatedBy).Enemy.IsA('ScriptedPawn'))
			{
				ScriptedPawn(InstigatedBy).Hated = None;
				ScriptedPawn(InstigatedBy).Enemy = None;
				ScriptedPawn(InstigatedBy).Target = None;
				ScriptedPawn(InstigatedBy).bHunting = False;
				ScriptedPawn(InstigatedBy).StartRoaming();
			}
			if (ScriptedPawn(InstigatedBy).OldEnemy != None && ScriptedPawn(InstigatedBy).OldEnemy.IsA('ScriptedPawn'))
				ScriptedPawn(InstigatedBy).OldEnemy = None;
		}
	}
	if ( instigatedBy != None && injured != None && ( injured == InstigatedBy || injured != instigatedBy ) && instigatedby.PlayerReplicationInfo == None )
			return Damage;

	if ( (instigatedBy != injured) && injured.PlayerReplicationInfo != None && instigatedBy.PlayerReplicationInfo != None
		&& (injured.PlayerReplicationInfo.Team ~= instigatedBy.PlayerReplicationInfo.Team) )
	{
		if ( injured.IsA('Bot') )
			Bot(Injured).YellAt(instigatedBy);
		return (Damage * FriendlyFireScale);
	}
	return Damage;
}

function DiscardInventory( Pawn Other ) //Guess why I did a... small look around
{
	local actor dropped;
	local inventory Inv;
	local weapon weap;
	local float speed;

	bHaveASpawn=True; //This has been called - look out how we replace stuff dropped in Base_Mute
	if( Other.DropWhenKilled != None )
	{
		dropped = Spawn(Other.DropWhenKilled,,,Other.Location); //Break in here if replacement works - next lines won't act anymore
		Inv = Inventory(dropped);
		if ( Inv != None )
		{
			Inv.RespawnTime = 0.0; //don't respawn - Nelsona: For sure not even replacements - except from decorations... RIGHT ???
			Inv.BecomePickup();
		}
		if ( dropped != None )
		{
			dropped.RemoteRole = ROLE_DumbProxy;
			dropped.SetPhysics(PHYS_Falling);
			dropped.bCollideWorld = true;
			dropped.Velocity = Other.Velocity + VRand() * 280;
		}
		if ( Inv != None )
			Inv.GotoState('PickUp', 'Dropped');
	}
	if( (Other.Weapon!=None) && (Other.Weapon.Class!=Level.Game.BaseMutator.MutatedDefaultWeapon()) 
		&& Other.Weapon.bCanThrow )
	{
		speed = VSize(Other.Velocity);
		weap = Other.Weapon;
		if (speed != 0)
			weap.Velocity = Normal(Other.Velocity/speed + 0.5 * VRand()) * (speed + 280);
		else {
			weap.Velocity.X = 0;
			weap.Velocity.Y = 0;
			weap.Velocity.Z = 0;
		}
		Other.TossWeapon();
		if ( weap.PickupAmmoCount == 0 )
			weap.PickupAmmoCount = 1;
	}
	Other.Weapon = None;
	Other.SelectedItem = None;
	for( Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory )
		Inv.Destroy();
	bHaveASpawn=False; //End, prepare to next one
}

defaultproperties
{
   MonsterSkill=7
   TT=MoHu
   Lives=200
   TimeOutMessage="Time up, hunt failed!"
   bSpawnInTeamArea=True
   bBalanceTeams=False
   bPlayersBalanceTeams=False
   MaxTeams=1
   MaxAllowedTeams=1
   GoalTeamScore=0.000000
   MaxTeamSize=16
   StartUpTeamMessage="Welcome to the hunt!"
   MinPlayers=5
   FragLimit=0
   TimeLimit=300
   bMultiWeaponStay=True
   bNoTeamChanges=True
   bBalanceTeams=False
   bPlayersBalanceTeams=False
   bCanChangeSkin=True
   NetWait=3
   RestartWait=3
   bUseTranslocator=False
   StartUpMessage="Work with your teammates to hunt down the monsters!"
   StartMessage="The hunt has begun!"
   GameEndedMessage="Hunt Successful!"
   SingleWaitingMessage="Press Fire to begin the hunt."
   MaxCommanders=0
   InitialBots=0
   ExplodeMessage=" was blown up"
   BurnedMessage=" was incinerated"
   CorrodedMessage=" was slimed"
   HackedMessage=" was hacked"
   DefaultWeapon=Class'UnrealShare.DispersionPistol'
   MaxSpectators=0
   AdminPassword=""
   ScoreBoardType=Class'MonsterHunt.MonsterBoard'
   BotMenuType="MonsterHunt.MonsterBotConfig"
   RulesMenuType="MonsterHunt.MonsterHuntRules"
   SettingsMenuType="MonsterHunt.MonsterSettings"
   HUDType=Class'MonsterHunt.MonsterHUD'
   MapListType=Class'MonsterHunt.MonsterMapList'
   MapPrefix="MH"
   BeaconName="MH"
   LeftMessage=" left the hunt."
   EnteredMessage=" has joined the hunt!"
   GameName="Monster Hunt"
   MaxPlayers=8
   DMMessageClass=Class'MonsterHunt.HuntMessage'
   MutatorClass=Class'MonsterHunt.MonsterBase'
   GameReplicationInfoClass=Class'MonsterHunt.MonsterReplicationInfo'
   StatLogClass=Class'MonsterHunt.MHLogFile'
}
